Open CASCADE Technology: Geom2d_Line Class Reference

Open CASCADE Technology 6.9.1

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions
Geom2d_Line Class Reference

Describes an infinite line in the plane (2D space). A line is defined and positioned in the plane with an axis (gp_Ax2d object) which gives it an origin and a unit vector. The Geom2d_Line line is parameterized as follows: P (U) = O + U*Dir where: More...

`#include <Geom2d_Line.hxx>`

Inheritance diagram for Geom2d_Line:
[legend]

## Public Member Functions
| Geom2d_Line (const gp_Ax2d &A)
| Creates a line located in 2D space with the axis placement A. The Location of A is the origin of the line. More...
| Geom2d_Line (const gp_Lin2d &L)
| Creates a line by conversion of the gp_Lin2d line L. More...
| Geom2d_Line (const gp_Pnt2d &P, const gp_Dir2d &V)
| Constructs a line passing through point P and parallel to vector V (P and V are, respectively, the origin and the unit vector of the positioning axis of the line). More...
void | SetLin2d (const gp_Lin2d &L)
| Set <me> so that <me> has the same geometric properties as L. More...
void | SetDirection (const gp_Dir2d &V)
| changes the direction of the line. More...
const gp_Dir2d & | Direction () const
| changes the direction of the line. More...
void | SetLocation (const gp_Pnt2d &P)
| Changes the "Location" point (origin) of the line. More...
const gp_Pnt2d & | Location () const
| Changes the "Location" point (origin) of the line. More...
void | SetPosition (const gp_Ax2d &A)
| Changes the "Location" and a the "Direction" of <me>. More...
const gp_Ax2d & | Position () const
gp_Lin2d | Lin2d () const
| Returns non persistent line from gp with the same geometric properties as <me> More...
void | Reverse ()
| Changes the orientation of this line. As a result, the unit vector of the positioning axis of this line is reversed. More...
Standard_Real | ReversedParameter (const Standard_Real U) const
| Computes the parameter on the reversed line for the point of parameter U on this line. For a line, the returned value is -U. More...
Standard_Real | FirstParameter () const
| Returns RealFirst from Standard. More...
Standard_Real | LastParameter () const
| Returns RealLast from Standard. More...
Standard_Boolean | IsClosed () const
| Returns False. More...
Standard_Boolean | IsPeriodic () const
| Returns False. More...
GeomAbs_Shape | Continuity () const
| Returns GeomAbs_CN, which is the global continuity of any line. More...
Standard_Real | Distance (const gp_Pnt2d &P) const
| Computes the distance between <me> and the point P. More...
Standard_Boolean | IsCN (const Standard_Integer N) const
| Returns True. More...
void | D0 (const Standard_Real U, gp_Pnt2d &P) const
| Returns in P the point of parameter U. P (U) = O + U * Dir where O is the "Location" point of the line and Dir the direction of the line. More...
void | D1 (const Standard_Real U, gp_Pnt2d &P, gp_Vec2d &V1) const
| Returns the point P of parameter u and the first derivative V1. More...
void | D2 (const Standard_Real U, gp_Pnt2d &P, gp_Vec2d &V1, gp_Vec2d &V2) const
| Returns the point P of parameter U, the first and second derivatives V1 and V2. V2 is a vector with null magnitude for a line. More...
void | D3 (const Standard_Real U, gp_Pnt2d &P, gp_Vec2d &V1, gp_Vec2d &V2, gp_Vec2d &V3) const
| V2 and V3 are vectors with null magnitude for a line. More...
gp_Vec2d | DN (const Standard_Real U, const Standard_Integer N) const
| For the point of parameter U of this line, computes the vector corresponding to the Nth derivative. Note: if N is greater than or equal to 2, the result is a vector with null magnitude. Exceptions Standard_RangeError if N is less than 1. More...
void | Transform (const gp_Trsf2d &T)
| Applies the transformation T to this line. More...
virtual Standard_Real | TransformedParameter (const Standard_Real U, const gp_Trsf2d &T) const
| Computes the parameter on the line transformed by T for the point of parameter U on this line. For a line, the returned value is equal to U multiplied by the scale factor of transformation T. More...
virtual Standard_Real | ParametricTransformation (const gp_Trsf2d &T) const
| Returns the coefficient required to compute the parametric transformation of this line when transformation T is applied. This coefficient is the ratio between the parameter of a point on this line and the parameter of the transformed point on the new line transformed by T. For a line, the returned value is the scale factor of the transformation T. More...
Handle< Geom2d_Geometry > | Copy () const
| Creates a new object, which is a copy of this line. More...
Public Member Functions inherited from Geom2d_Curve
Handle< Geom2d_Curve > | Reversed () const
| Creates a reversed duplicate Changes the orientation of this curve. The first and last parameters are not changed, but the parametric direction of the curve is reversed. If the curve is bounded: More...
virtual Standard_Real | Period () const
| Returns thne period of this curve. raises if the curve is not periodic. More...
gp_Pnt2d | Value (const Standard_Real U) const
| Computes the point of parameter U on <me>. If the curve is periodic then the returned point is P(U) with U = Ustart + (U - Uend) where Ustart and Uend are the parametric bounds of the curve. More...
Public Member Functions inherited from Geom2d_Geometry
void | Mirror (const gp_Pnt2d &P)
| Performs the symmetrical transformation of a Geometry with respect to the point P which is the center of the symmetry and assigns the result to this geometric object. More...
void | Mirror (const gp_Ax2d &A)
| Performs the symmetrical transformation of a Geometry with respect to an axis placement which is the axis of the symmetry. More...
void | Rotate (const gp_Pnt2d &P, const Standard_Real Ang)
| Rotates a Geometry. P is the center of the rotation. Ang is the angular value of the rotation in radians. More...
void | Scale (const gp_Pnt2d &P, const Standard_Real S)
| Scales a Geometry. S is the scaling value. More...
void | Translate (const gp_Vec2d &V)
| Translates a Geometry. V is the vector of the tanslation. More...
void | Translate (const gp_Pnt2d &P1, const gp_Pnt2d &P2)
| Translates a Geometry from the point P1 to the point P2. More...
Handle< Geom2d_Geometry > | Mirrored (const gp_Pnt2d &P) const
Handle< Geom2d_Geometry > | Mirrored (const gp_Ax2d &A) const
Handle< Geom2d_Geometry > | Rotated (const gp_Pnt2d &P, const Standard_Real Ang) const
Handle< Geom2d_Geometry > | Scaled (const gp_Pnt2d &P, const Standard_Real S) const
Handle< Geom2d_Geometry > | Transformed (const gp_Trsf2d &T) const
Handle< Geom2d_Geometry > | Translated (const gp_Vec2d &V) const
Handle< Geom2d_Geometry > | Translated (const gp_Pnt2d &P1, const gp_Pnt2d &P2) const
Public Member Functions inherited from MMgt_TShared
virtual void | Delete () const
| Memory deallocator for transient classes. More...
Public Member Functions inherited from Standard_Transient
| Standard_Transient ()
| Empty constructor. More...
| Standard_Transient (const Standard_Transient &)
| Copy constructor – does nothing. More...
Standard_Transient & | operator= (const Standard_Transient &)
| Assignment operator, needed to avoid copying reference counter. More...
virtual | ~Standard_Transient ()
| Destructor must be virtual. More...
virtual const Handle_Standard_Type & | DynamicType () const
| Returns a type information object about this object. More...
Standard_Boolean | IsInstance (const Handle_Standard_Type &theType) const
| Returns a true value if this is an instance of Type. More...
Standard_Boolean | IsInstance (const Standard_CString theTypeName) const
| Returns a true value if this is an instance of TypeName. More...
Standard_Boolean | IsKind (const Handle_Standard_Type &theType) const
| Returns true if this is an instance of Type or an instance of any class that inherits from Type. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
Standard_Boolean | IsKind (const Standard_CString theTypeName) const
| Returns true if this is an instance of TypeName or an instance of any class that inherits from TypeName. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
virtual Handle_Standard_Transient | This () const
| Returns a Handle which references this object. Must never be called to objects created in stack. More...
Standard_Integer | GetRefCount () const
| Get the reference counter of this object. More...

## Detailed Description

Describes an infinite line in the plane (2D space). A line is defined and positioned in the plane with an axis (gp_Ax2d object) which gives it an origin and a unit vector. The Geom2d_Line line is parameterized as follows: P (U) = O + U*Dir where:

- P is the point of parameter U,
- O is the origin and Dir the unit vector of its positioning axis. The parameter range is ] -infinite, +infinite [. The orientation of the line is given by the unit vector of its positioning axis. See Also GCE2d_MakeLine which provides functions for more complex line constructions gp_Ax2d gp_Lin2d for an equivalent, non-parameterized data structure.

## Constructor & Destructor Documentation

Geom2d_Line::Geom2d_Line | ( | const gp_Ax2d & | A | ) |

Creates a line located in 2D space with the axis placement A. The Location of A is the origin of the line.

Geom2d_Line::Geom2d_Line | ( | const gp_Lin2d & | L | ) |

Creates a line by conversion of the gp_Lin2d line L.

Geom2d_Line::Geom2d_Line | ( | const gp_Pnt2d & | P,
|  | const gp_Dir2d & | V
| ) |  |

Constructs a line passing through point P and parallel to vector V (P and V are, respectively, the origin and the unit vector of the positioning axis of the line).

## Member Function Documentation

GeomAbs_Shape Geom2d_Line::Continuity | ( |  | ) | const
| virtual

Returns GeomAbs_CN, which is the global continuity of any line.

Implements Geom2d_Curve.

Handle< Geom2d_Geometry > Geom2d_Line::Copy | ( |  | ) | const
| virtual

Creates a new object, which is a copy of this line.

Implements Geom2d_Geometry.

void Geom2d_Line::D0 | ( | const Standard_Real | U,
|  | gp_Pnt2d & | P
| ) |  | const
| virtual

Returns in P the point of parameter U. P (U) = O + U * Dir where O is the "Location" point of the line and Dir the direction of the line.

Implements Geom2d_Curve.

void Geom2d_Line::D1 | ( | const Standard_Real | U,
|  | gp_Pnt2d & | P,
|  | gp_Vec2d & | V1
| ) |  | const
| virtual

Returns the point P of parameter u and the first derivative V1.

Implements Geom2d_Curve.

void Geom2d_Line::D2 | ( | const Standard_Real | U,
|  | gp_Pnt2d & | P,
|  | gp_Vec2d & | V1,
|  | gp_Vec2d & | V2
| ) |  | const
| virtual

Returns the point P of parameter U, the first and second derivatives V1 and V2. V2 is a vector with null magnitude for a line.

Implements Geom2d_Curve.

void Geom2d_Line::D3 | ( | const Standard_Real | U,
|  | gp_Pnt2d & | P,
|  | gp_Vec2d & | V1,
|  | gp_Vec2d & | V2,
|  | gp_Vec2d & | V3
| ) |  | const
| virtual

V2 and V3 are vectors with null magnitude for a line.

Implements Geom2d_Curve.

const gp_Dir2d& Geom2d_Line::Direction | ( |  | ) | const

changes the direction of the line.

Standard_Real Geom2d_Line::Distance | ( | const gp_Pnt2d & | P | ) | const

Computes the distance between <me> and the point P.

gp_Vec2d Geom2d_Line::DN | ( | const Standard_Real | U,
|  | const Standard_Integer | N
| ) |  | const
| virtual

For the point of parameter U of this line, computes the vector corresponding to the Nth derivative. Note: if N is greater than or equal to 2, the result is a vector with null magnitude. Exceptions Standard_RangeError if N is less than 1.

Implements Geom2d_Curve.

Standard_Real Geom2d_Line::FirstParameter | ( |  | ) | const
| virtual

Returns RealFirst from Standard.

Implements Geom2d_Curve.

Standard_Boolean Geom2d_Line::IsClosed | ( |  | ) | const
| virtual

Returns False.

Implements Geom2d_Curve.

Standard_Boolean Geom2d_Line::IsCN | ( | const Standard_Integer | N | ) | const
| virtual

Returns True.

Implements Geom2d_Curve.

Standard_Boolean Geom2d_Line::IsPeriodic | ( |  | ) | const
| virtual

Returns False.

Implements Geom2d_Curve.

Standard_Real Geom2d_Line::LastParameter | ( |  | ) | const
| virtual

Returns RealLast from Standard.

Implements Geom2d_Curve.

gp_Lin2d Geom2d_Line::Lin2d | ( |  | ) | const

Returns non persistent line from gp with the same geometric properties as <me>

const gp_Pnt2d& Geom2d_Line::Location | ( |  | ) | const

Changes the "Location" point (origin) of the line.

virtual Standard_Real Geom2d_Line::ParametricTransformation | ( | const gp_Trsf2d & | T | ) | const
| virtual

Returns the coefficient required to compute the parametric transformation of this line when transformation T is applied. This coefficient is the ratio between the parameter of a point on this line and the parameter of the transformed point on the new line transformed by T. For a line, the returned value is the scale factor of the transformation T.

Reimplemented from Geom2d_Curve.

const gp_Ax2d& Geom2d_Line::Position | ( |  | ) | const

void Geom2d_Line::Reverse | ( |  | ) |
| virtual

Changes the orientation of this line. As a result, the unit vector of the positioning axis of this line is reversed.

Implements Geom2d_Curve.

Standard_Real Geom2d_Line::ReversedParameter | ( | const Standard_Real | U | ) | const
| virtual

Computes the parameter on the reversed line for the point of parameter U on this line. For a line, the returned value is -U.

Implements Geom2d_Curve.

void Geom2d_Line::SetDirection | ( | const gp_Dir2d & | V | ) |

changes the direction of the line.

void Geom2d_Line::SetLin2d | ( | const gp_Lin2d & | L | ) |

Set <me> so that <me> has the same geometric properties as L.

void Geom2d_Line::SetLocation | ( | const gp_Pnt2d & | P | ) |

Changes the "Location" point (origin) of the line.

void Geom2d_Line::SetPosition | ( | const gp_Ax2d & | A | ) |

Changes the "Location" and a the "Direction" of <me>.

void Geom2d_Line::Transform | ( | const gp_Trsf2d & | T | ) |
| virtual

Applies the transformation T to this line.

Implements Geom2d_Geometry.

virtual Standard_Real Geom2d_Line::TransformedParameter | ( | const Standard_Real | U,
|  | const gp_Trsf2d & | T
| ) |  | const
| virtual

Computes the parameter on the line transformed by T for the point of parameter U on this line. For a line, the returned value is equal to U multiplied by the scale factor of transformation T.

Reimplemented from Geom2d_Curve.

The documentation for this class was generated from the following file:

- Geom2d_Line.hxx